import { FileStreamOpt, StdoutStreamOpt } from '../../streams';
import { IncreaseResult } from '../../types';
export interface Mapper {
    stdio: StdoutStreamOpt;
    file: FileStreamOpt;
}
export interface BaseProcessOpts<T extends keyof Mapper> {
    since?: string;
    cwd?: string;
    output?: boolean;
    hash?: string;
    stream: {
        name?: T;
        opts?: T extends 'stdio' ? StdoutStreamOpt : FileStreamOpt;
    };
}
export declare class BaseProcess<T extends keyof Mapper> {
    lcovPath: string[];
    opts: BaseProcessOpts<T>;
    private lcov;
    private firstGitMessage;
    private diffData;
    private formatData;
    private firstInfo;
    constructor(lcovPath: string | string[], opts?: BaseProcessOpts<T>);
    exec(): Promise<IncreaseResult>;
    private getLcov;
    private getLog;
    private getDiff;
    private format;
    private output;
    private createInfo;
    private getInfoByHash;
}
export * from './async';
