"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.increaseLcovConcat = exports.lcovConcat = void 0;
const path_1 = __importDefault(require("path"));
const concat_1 = require("./concat");
const parsers_1 = require("../../parsers");
const getIncrease_1 = require("../getIncrease");
__exportStar(require("./concat"), exports);
function lcovConcat(...lcovPath) {
    return __awaiter(this, void 0, void 0, function* () {
        const lcovSet = new Set();
        for (const item of lcovPath) {
            lcovSet.add(path_1.default.resolve(item));
        }
        const parserPromise = [];
        for (const item of lcovSet) {
            parserPromise.push(new parsers_1.LcovParser(item).run());
        }
        const res = yield Promise.all(parserPromise);
        return new concat_1.LcovConcat().concat(...res).getRes();
    });
}
exports.lcovConcat = lcovConcat;
function increaseLcovConcat(opts, ...lcovPath) {
    return __awaiter(this, void 0, void 0, function* () {
        const lcovSet = new Set();
        for (const item of lcovPath) {
            lcovSet.add(path_1.default.resolve(item));
        }
        const parserPromise = [];
        for (const item of lcovSet) {
            parserPromise.push((() => __awaiter(this, void 0, void 0, function* () {
                var _a, _b, _c;
                const format = yield new getIncrease_1.BaseProcess(item, opts).exec();
                const temp = {
                    $: {
                        linesCovered: format.data.total.covLine,
                        linesValid: format.data.total.increLine,
                    },
                    detail: {},
                    increaseResultList: []
                };
                for (const formatItem of format.data.files) {
                    const rate = (_a = formatItem.increRate) === null || _a === void 0 ? void 0 : _a.substr(0, ((_b = formatItem.increRate) === null || _b === void 0 ? void 0 : _b.length) - 1);
                    const detail = [];
                    if (formatItem.detail) {
                        for (const detailItem of formatItem.detail) {
                            detail.push({
                                hits: detailItem.hits,
                                number: detailItem.number.toString(),
                            });
                        }
                    }
                    temp.detail[formatItem.name] = {
                        linesValid: formatItem.increLine,
                        linesCovered: formatItem.covLine,
                        lineRate: +rate,
                        lines: detail,
                    };
                    (_c = temp.increaseResultList) === null || _c === void 0 ? void 0 : _c.push(format);
                }
                return temp;
            }))());
        }
        const res = yield Promise.all(parserPromise);
        return new concat_1.LcovConcat().concat(...res).getRes();
    });
}
exports.increaseLcovConcat = increaseLcovConcat;
