export interface Total {
    linesCovered: number;
    linesValid: number;
}
export interface DetailLines {
    linesCovered: number;
    linesValid: number;
    lineRate: number;
    lines: {
        hits: number;
        number: string;
    }[];
}
export interface Lcov {
    detail: Record<string, DetailLines>;
    $?: Total;
    increaseResultList?: IncreaseResult[];
}
export interface FormatData {
    total: {
        increLine: number;
        covLine: number;
        increRate: string;
    };
    files: {
        name: string;
        increLine?: number;
        covLine?: number;
        increRate?: string;
        detail?: {
            number: number;
            hits: number;
        }[];
    }[];
}
export interface CommitBase {
    files?: string[];
    abbrevHash?: string;
    hash?: string;
    subject?: string;
    authorName?: string;
    authorDate?: string;
}
export interface FirstInfo {
    hash?: string;
    abbrevHash?: string;
    subject?: string;
    authorName?: string;
    authorDate?: string;
    authorEmail?: string;
}
export interface IncreaseResult {
    data: FormatData;
    commit: CommitBase;
    createInfo: FirstInfo;
}
